"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-plugin-typescript/src/tables/templates/read-item.ts
var read_item_exports = {};
__export(read_item_exports, {
  readItemTemplate: () => readItemTemplate
});
module.exports = __toCommonJS(read_item_exports);
var import_ensure_table = require("./ensure-table.cjs");
var import_helpers = require("./helpers.cjs");
function readItemTemplate(config, model) {
  const {
    consistent,
    primaryKey,
    table: { tableName },
    typeName
  } = model;
  const key = (0, import_helpers.makeKeyForRead)(config, primaryKey);
  const outputTypeName = `Read${typeName}Output`;
  const primaryKeyType = `${typeName}PrimaryKey`;
  return `
export type ${outputTypeName} = ResultType<${typeName}>;

/**  */
export async function read${typeName}(input: ${primaryKeyType}): Promise<Readonly<${outputTypeName}>> {
${(0, import_ensure_table.ensureTableTemplate)(tableName)}

  const commandInput: GetCommandInput = {
    ConsistentRead: ${consistent},
    Key: ${(0, import_helpers.objectToString)(key)},
    ReturnConsumedCapacity: 'INDEXES',
    TableName: tableName,
  };

  try {
    const {ConsumedCapacity: capacity, Item: item} = await ddbDocClient.send(new GetCommand(commandInput));

    assert(capacity, 'Expected ConsumedCapacity to be returned. This is a bug in codegen.');

    assert(item, () => new NotFoundError('${typeName}', input));
    assert(item._et === '${typeName}', () => new DataIntegrityError(\`Expected \${JSON.stringify(input)} to load a ${typeName} but loaded \${item._et} instead\`));

    return {
      capacity,
      item: unmarshall${typeName}(item),
      metrics: undefined,
    }
  }
  catch (err) {
    ${(0, import_helpers.handleCommonErrors)()}
  }
}`;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  readItemTemplate
});
//# sourceMappingURL=read-item.cjs.map
