"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-plugin-typescript/src/tables/templates/update-item.ts
var update_item_exports = {};
__export(update_item_exports, {
  updateItemTemplate: () => updateItemTemplate
});
module.exports = __toCommonJS(update_item_exports);
var import_helpers = require("../../helpers.cjs");
var import_computed_fields = require("../computed-fields.cjs");
var import_ensure_table = require("./ensure-table.cjs");
var import_helpers2 = require("./helpers.cjs");
function updateItemTemplate(config, model) {
  const {
    fields,
    isPublic: hasPublicId,
    primaryKey,
    table: { tableName },
    ttlConfig,
    typeName
  } = model;
  const key = (0, import_helpers2.makeKeyForRead)(config, primaryKey);
  const marshallPrimaryKey = (0, import_helpers2.objectToString)(
    Object.fromEntries(
      (primaryKey.isComposite ? [...primaryKey.partitionKeyFields, ...primaryKey.sortKeyFields] : primaryKey.partitionKeyFields).map(({ fieldName }) => fieldName).sort().map((fieldName) => [fieldName, `input.${fieldName}`])
    )
  );
  const primaryKeyFields = (primaryKey.isComposite ? [...primaryKey.partitionKeyFields, ...primaryKey.sortKeyFields] : primaryKey.partitionKeyFields).map(({ fieldName }) => fieldName);
  const inputTypeName = `Update${typeName}Input`;
  const omitInputFields = [
    "id",
    "createdAt",
    "updatedAt",
    hasPublicId && "publicId",
    ttlConfig?.fieldName,
    ...fields.filter(({ computeFunction }) => !!computeFunction).map(({ fieldName }) => fieldName)
  ].filter(import_helpers.filterNull).filter((fieldName) => !primaryKeyFields.includes(fieldName)).map((f) => `'${f}'`).sort();
  const outputTypeName = `Update${typeName}Output`;
  return `
export type ${inputTypeName} = Omit<${typeName}, ${omitInputFields.join(
    "|"
  )}> ${ttlConfig ? ` & Partial<Pick<${typeName}, '${ttlConfig.fieldName}'>>` : ""};
export type ${outputTypeName} = ResultType<${typeName}>

/**  */
export async function update${typeName}(${(0, import_computed_fields.inputName)(
    model
  )}: Readonly<${inputTypeName}>): Promise<Readonly<${outputTypeName}>> {
${(0, import_ensure_table.ensureTableTemplate)(tableName)}
  ${(0, import_computed_fields.defineComputedInputFields)(fields, typeName)}
  const {ExpressionAttributeNames, ExpressionAttributeValues, UpdateExpression} = marshall${typeName}(input);
  try {
    let previousVersionCE = '';
    let previousVersionEAV = {};
    if ('version' in input && typeof input.version !== 'undefined') {
      previousVersionCE = '#version = :previousVersion AND ';
      previousVersionEAV = {':previousVersion': input.version,}
    }
    const commandInput: UpdateCommandInput = {
      ConditionExpression: \`\${previousVersionCE}#entity = :entity AND attribute_exists(#pk)\`,
      ExpressionAttributeNames,
      ExpressionAttributeValues: {
        ...ExpressionAttributeValues,
        ...previousVersionEAV
      },
      Key: ${(0, import_helpers2.objectToString)(key)},
      ReturnConsumedCapacity: 'INDEXES',
      ReturnItemCollectionMetrics: 'SIZE',
      ReturnValues: 'ALL_NEW',
      TableName: tableName,
      UpdateExpression,
    };

    const {Attributes: item, ConsumedCapacity: capacity, ItemCollectionMetrics: metrics} = await ddbDocClient.send(new UpdateCommand(commandInput));

    assert(capacity, 'Expected ConsumedCapacity to be returned. This is a bug in codegen.');

    assert(item, 'Expected DynamoDB to return an Attributes prop.');
    assert(item._et === '${typeName}', () => new DataIntegrityError(\`Expected \${JSON.stringify(${marshallPrimaryKey})} to update a ${typeName} but updated \${item._et} instead\`));

    return {
      capacity,
      item: unmarshall${typeName}(item),
      metrics,
    }
  }
  catch (err) {
    if (err instanceof ConditionalCheckFailedException) {
      try {
        await read${typeName}(input);
      }
      catch {
        throw new NotFoundError('${typeName}', ${marshallPrimaryKey});
      }
      throw new OptimisticLockingError('${typeName}', ${marshallPrimaryKey});
    }
    ${(0, import_helpers2.handleCommonErrors)()}
  }
}`;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  updateItemTemplate
});
//# sourceMappingURL=update-item.cjs.map
